#! /usr/bin/perl 

#########################################################################################
# Input: 1. COGFILE - the list of COGs, with the functional category and description
#	 2. DATAFILE - the file to be processed
# Output: substitute the corresponding description for each occurrance of COG in COGFILE
##########################################################################################

# Read the COG description into a hash table
open( COGFILE, "<$ARGV[0]" ) || die "Can't open the file $ARGV[0]\n";

while ( <COGFILE> ) {
	( $fun_cat, $COG_id, $desc ) = split "\t";
	chomp $desc;
	$COG_desc{ $COG_id } = $desc;
}

#foreach ( keys( %COG_desc ) ) { print $_, "\t", $COG_desc{ $_ }, "\n"; }

# Substitute each occurrance of COG to its description
open ( DATAFILE, "<$ARGV[1]" ) || die "Can't open the file $ARGV[1]\n";

while ( <DATAFILE> ) {
	chomp;
	if ( $_ =~ m/^\s*COG\d+/ ) {
		@COGs = split ":";
		if ( scalar( @COGs ) <= 2 ) {
			next;
		} else {
			#foreach ( @COGs ) { print $_, "\t"; };
			@descs = map { $COG_desc{ $_ }."($_)" } @COGs;
			$desc_str = join " AND ", @descs;
			print "$desc_str\n\n";
		}
	}
}


